/*
 * JBoss, Home of Professional Open Source
 * Copyright 2009, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * (C) 2009
 * @author JBoss Inc.
 */
package org.jboss.jbossts.rts.demo.client.service;

import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.Button;

public class Taxi extends ServicePanel
{
	static private String[] yesno = {"No", "Yes"};

	public Taxi(String serviceUrl, final StatusPanel summary)
	{
		super("Taxi", "Taxi Service - Booking Form", serviceUrl, summary);

		ListBox taxiLb = createListBox(true, "dropdown", 1, yesno);

		add(new Label("Book a taxi?"));
		add(taxiLb);
		fini();

		addWidgetBinding("status", new WidgetBinding("Unknown") {
			public void onSuccess(String value) {summary.updateTaxiStatus(value);}
		});
		addWidgetBinding("taxi", new ListBoxWidgetBinding(taxiLb, 1) {
			public void onSuccess(String value) {summary.updateTaxi("Yes".equals(value));}
		});

	}
}
