package org.jboss.jbossts.rts.service;

import com.arjuna.ats.arjuna.recovery.RecoveryManager;

import javax.ws.rs.core.Application;
import javax.ws.rs.ext.ExceptionMapper;
import java.util.Set;
import java.util.HashSet;
import java.util.Arrays;

import org.jboss.resteasy.spi.ResteasyProviderFactory;
import org.jboss.resteasy.plugins.server.embedded.EmbeddedJaxrsServer;
import org.jboss.jbossts.rts.provider.NotFoundMapper;
import org.jboss.jbossts.rts.provider.TMUnavailableMapper;
import org.jboss.jbossts.rts.provider.TransactionStatusMapper;
import org.jboss.jbossts.rts.provider.HttpResponseMapper;

public class TMApplication extends Application
{
    HashSet<Object> singletons = new HashSet<Object>();

    public TMApplication()
    {
        try
        {
            // TODO move com/arjuna/ats/jbossatx/jt[as]/TransactionManagerService.isRecoveryManagerRunning
            // to RecoveryManager and change logging
            if ("true".equals(System.getProperty("recovery", "true")))
                RecoveryManager.manager();
        }
        catch (Throwable e)
        {
            // did it really fail or was it already running?
            System.err.println("INFO: " + e.getMessage());
        }
    }

    @Override
    public Set<Class<?>> getClasses()
    {
        return new HashSet<Class<?>>();
    }

    @Override
    public Set<Object> getSingletons()
    {
        if (singletons.isEmpty())
            singletons.addAll(Arrays.asList(resources));

        return singletons;
    }

    public static void initApplication(EmbeddedJaxrsServer server)
    {
        ResteasyProviderFactory pf = server.getFactory();

        for (Class<?> m : mappers)
            pf.addExceptionMapper((Class<? extends ExceptionMapper>) m);

        for (Object obj : resources)
            server.getRegistry().addSingletonResource(obj);
    }

    private static Class<?>[] mappers = {
        NotFoundMapper.class,
        TMUnavailableMapper.class,
        TransactionStatusMapper.class,
        HttpResponseMapper.class
    };
    
    private static Object[] resources = {
            new Coordinator(),
            new org.jboss.jbossts.rts.example.Participant()
    };  
}
